package inua.elf;

public class NT
{
  static public final int PRSTATUS = 1;
  static public final int FPREGSET = 2;
  static public final int PRPSINFO = 3;
  static public final int TASKSTRUCT = 4;
  static public final int AUXV = 6;

  static public String toString (long i)
  {
    switch ((int) i) {
    case PRSTATUS: return "NT_PRSTATUS";
    case FPREGSET: return "NT_FPREGSET";
    case PRPSINFO: return "NT_PRPSINFO";
    case TASKSTRUCT: return "NT_TASKSTRUCT";
    case AUXV: return "NT_AUXV";
    default: return "NT_0x" + Long.toHexString (i);
    }
  }

  static public String toShortString (long i)
  {
    switch ((int) i) {
    case PRSTATUS: return "PRSTATUS";
    case FPREGSET: return "FPREGSET";
    case PRPSINFO: return "PRPSINFO";
    case TASKSTRUCT: return "TASKSTRUCT";
    case AUXV: return "AUXV";
    default: return "NT_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i)
  {
    switch ((int) i) {
    case PRSTATUS: return "prstatus structure";
    case FPREGSET: return "floating point registers";
    case PRPSINFO: return "prpsinfo structure";
    case TASKSTRUCT: return "task structure";
    case AUXV: return "auxiliary vector";
    default: return "NT_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i, String def)
  {
    switch ((int) i) {
    case PRSTATUS: return "prstatus structure";
    case FPREGSET: return "floating point registers";
    case PRPSINFO: return "prpsinfo structure";
    case TASKSTRUCT: return "task structure";
    case AUXV: return "auxiliary vector";
    default: return def;
    }
  }
}
