package inua.elf;

public class SHT
{
  static public final int NULL = 0;
  static public final int PROGBITS = 1;
  static public final int SYMTAB = 2;
  static public final int STRTAB = 3;
  static public final int RELA = 4;
  static public final int HASH = 5;
  static public final int DYNAMIC = 6;
  static public final int NOTE = 7;
  static public final int NOBITS = 8;
  static public final int REL = 9;
  static public final int SHLIB = 10;
  static public final int DYNSYM = 11;
  static public final int VERSYM = 0x6fffffff;
  static public final int VERNEED = 0x6ffffffe;
  static public final int LOPROC = 0x70000000;
  static public final int HIPROC = 0x7fffffff;
  static public final int LOUSER = 0x80000000;
  static public final int HIUSER = 0xffffffff;

  static public String toString (long i)
  {
    switch ((int) i) {
    case NULL: return "SHT_NULL";
    case PROGBITS: return "SHT_PROGBITS";
    case SYMTAB: return "SHT_SYMTAB";
    case STRTAB: return "SHT_STRTAB";
    case RELA: return "SHT_RELA";
    case HASH: return "SHT_HASH";
    case DYNAMIC: return "SHT_DYNAMIC";
    case NOTE: return "SHT_NOTE";
    case NOBITS: return "SHT_NOBITS";
    case REL: return "SHT_REL";
    case SHLIB: return "SHT_SHLIB";
    case DYNSYM: return "SHT_DYNSYM";
    case VERSYM: return "SHT_VERSYM";
    case VERNEED: return "SHT_VERNEED";
    default: return "SHT_0x" + Long.toHexString (i);
    }
  }

  static public String toShortString (long i)
  {
    switch ((int) i) {
    case NULL: return "NULL";
    case PROGBITS: return "PROGBITS";
    case SYMTAB: return "SYMTAB";
    case STRTAB: return "STRTAB";
    case RELA: return "RELA";
    case HASH: return "HASH";
    case DYNAMIC: return "DYNAMIC";
    case NOTE: return "NOTE";
    case NOBITS: return "NOBITS";
    case REL: return "REL";
    case SHLIB: return "SHLIB";
    case DYNSYM: return "DYNSYM";
    case VERSYM: return "VERSYM";
    case VERNEED: return "VERNEED";
    default: return "SHT_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i)
  {
    switch ((int) i) {
    case NULL: return "NULL";
    case PROGBITS: return "PROGBITS";
    case SYMTAB: return "SYMTAB";
    case STRTAB: return "STRTAB";
    case RELA: return "RELA";
    case HASH: return "HASH";
    case DYNAMIC: return "DYNAMIC";
    case NOTE: return "NOTE";
    case NOBITS: return "NOBITS";
    case REL: return "REL";
    case SHLIB: return "SHLIB";
    case DYNSYM: return "DYNSYM";
    case VERSYM: return "VERSYM";
    case VERNEED: return "VERNEED";
    default: return "SHT_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i, String def)
  {
    switch ((int) i) {
    case NULL: return "NULL";
    case PROGBITS: return "PROGBITS";
    case SYMTAB: return "SYMTAB";
    case STRTAB: return "STRTAB";
    case RELA: return "RELA";
    case HASH: return "HASH";
    case DYNAMIC: return "DYNAMIC";
    case NOTE: return "NOTE";
    case NOBITS: return "NOBITS";
    case REL: return "REL";
    case SHLIB: return "SHLIB";
    case DYNSYM: return "DYNSYM";
    case VERSYM: return "VERSYM";
    case VERNEED: return "VERNEED";
    default: return def;
    }
  }
}
