package inua.elf;

public class STB
{
  static public final int LOCAL = 0;
  static public final int GLOBAL = 1;
  static public final int WEAK = 2;
  static public final int LOPROC = 13;
  static public final int HIPROC = 15;

  static public String toString (long i)
  {
    switch ((int) i) {
    case LOCAL: return "STB_LOCAL";
    case GLOBAL: return "STB_GLOBAL";
    case WEAK: return "STB_WEAK";
    case LOPROC: return "STB_LOPROC";
    case HIPROC: return "STB_HIPROC";
    default: return "STB_0x" + Long.toHexString (i);
    }
  }

  static public String toShortString (long i)
  {
    switch ((int) i) {
    case LOCAL: return "LOCAL";
    case GLOBAL: return "GLOBAL";
    case WEAK: return "WEAK";
    case LOPROC: return "LOPROC";
    case HIPROC: return "HIPROC";
    default: return "STB_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i)
  {
    switch ((int) i) {
    case LOCAL: return "LOCAL";
    case GLOBAL: return "GLOBAL";
    case WEAK: return "WEAK";
    case LOPROC: return "LOPROC";
    case HIPROC: return "HIPROC";
    default: return "STB_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i, String def)
  {
    switch ((int) i) {
    case LOCAL: return "LOCAL";
    case GLOBAL: return "GLOBAL";
    case WEAK: return "WEAK";
    case LOPROC: return "LOPROC";
    case HIPROC: return "HIPROC";
    default: return def;
    }
  }
}
